﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace DR1KP
{
    public partial class Form1 : Form
    {
        List<GpsData> gpsDataList;
        Timer timer;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // ブラウザに地図を
            string appDir = Path.GetDirectoryName(Application.ExecutablePath);
            webBrowser1.Navigate("file:///" + appDir + @"\sengoku38.html");

            // 大麻
            timer = new Timer();
            timer.Tick += new EventHandler(TimerEvent);
            timer.Interval = 333;   // 適当に1/3秒。
            timer.Start();
        }

        private void TimerEvent(object sender, EventArgs e)
        {
            if (axWindowsMediaPlayer1.playState == WMPLib.WMPPlayState.wmppsPlaying && 0 < gpsDataList.Count)
            {
                // 再生中の位置。単位は秒。
                double cp = axWindowsMediaPlayer1.Ctlcontrols.currentPosition;

                // GPSデータは1秒ごとなので、そのまま使う。
                // ※MP4のデータを詳細に解析して同期したほうがイイかも？
                int index = Math.Min((int)cp, gpsDataList.Count - 1);

                // GPSデータを取ってきて
                GpsData gpdData = gpsDataList[index];

                // 場所を地図に反映する
                object[] args = new object[] { gpdData.lat, gpdData.lng };
                webBrowser1.Document.InvokeScript("panty", args);
            }
        }

        private void play(string filename)
        {
            try
            {
                // 読む
                MP4Reader r = new MP4Reader();
                gpsDataList = r.gpsRead(filename);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "スマソ");
                return;
            }

            // 再生開始
            axWindowsMediaPlayer1.URL = filename;
        }

        private void splitContainer2_Panel2_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop) == true)
            {
                e.Effect = DragDropEffects.All;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void splitContainer2_Panel2_DragDrop(object sender, DragEventArgs e)
        {
            // ドロップされた情報からファイルパスをゲット
            foreach (string strFileName in (string[])e.Data.GetData(DataFormats.FileDrop))
            {
                // ファイル名表示
                lblFileName.Text = Path.GetFileName(strFileName);
                // 画面更新（ラベル更新）
                Refresh();

                // 読んで再生開始！
                Cursor = Cursors.WaitCursor;
                play(strFileName);
                Cursor = Cursors.Default;
            }
        }
    }
}