﻿class GpsData
{
    public double lat;
    public double lng;

    public GpsData(string nmearmc)
    {
        // 参考 http://bg66.soc.i.kyoto-u.ac.jp/forestgps/nmea.html
        // の、RMC

        string[] cols = nmearmc.Split(',');
        string utctime = cols[1];   // hhmmss.xxx
        string status = cols[2];    // A:有効 V:無効
        string lat_dm = cols[3];    // ddmm.mmm
        string lat_ns = cols[4];    // N or S
        string lng_dm = cols[5];    // dddmm.mmm
        string lng_ew = cols[6];    // E or W
        string speed = cols[7];     // 対地速度（ノット）
        string dir = cols[8];       // 進行方向（度，真北）ddd.d
        string utcdate = cols[9];   // ddmmyy

        int lat_dotindex = lat_dm.IndexOf('.');
        string lat_d = lat_dm.Substring(0, lat_dotindex - 2);   // 度
        string lat_m = lat_dm.Substring(lat_dotindex - 2);      // 分

        int lng_dotindex = lng_dm.IndexOf('.');
        string lng_d = lng_dm.Substring(0, lng_dotindex - 2);   // 度
        string lng_m = lng_dm.Substring(lng_dotindex - 2);      // 分

        this.lat = int.Parse(lat_d) + double.Parse(lat_m) / 60.0;
        this.lng = int.Parse(lng_d) + double.Parse(lng_m) / 60.0;

        if (lat_ns != "N") this.lat = -this.lat;
        if (lng_ew != "E") this.lng = -this.lng;
    }
}
